proc p_removespace {str}\
{
	set a $str
	regsub -all {\\ } $a {~S~P} a
	regsub -all {\\	} $a {~T~A} a
	regsub -all { } $a {_} a
	regsub -all "\t" $a {_} a
	regsub -all {~S~P} $a {\ } a
	regsub -all {~T~A} $a {\	} a
	return $a
}

proc p_getniv {str}\
{
	set a $str
	set niv 0
	while {[regsub "^\n*\t" $a "" a]}\
	{
		incr niv
	}
	return $niv
}

proc p_getexpos {}\
{
	set curtype ""
	set curtag id0
	set niv 0
	set ct [
		catch {
			set curtype [p_gettype redsel.last-1c]
			set curtag [p_gettag redsel.last-1c]
			set tx [.lf.tx get $curtag.first $curtag.last]
			set niv [p_getniv "$tx"]
		} errmsg
	]
	if {$curtype == "" || $curtag == "id0"}\
	{
		return id0
	}\
	elseif {$curtype == "eblock" || $curtype == "glob"}\
	{
		return $curtag
	}\
	else\
	{
		while {$curtype != "act" && $curtype != "eblock" && $curtype != ""}\
		{
			set curtype [p_gettype $curtag.last+1c]
			set curtag [p_gettag $curtag.last+1c]
		}
		if {$curtag == ""}\
		{
			return id0
		}\
		else\
		{
			return $curtag
		}
	}
}

proc p_modify {localx localy globalx globaly}\
{
	global STEP ID CURPOS asked tab_str
	.right unpost
	.right delete 0 end
	set curtype [p_gettype @$localx,$localy]
	set curtag [p_gettag @$localx,$localy]
	if {$curtype == "" || $curtype == "start" || $curtype == "sblock" || $curtype == "eblock"}\
	{
		return
	}\
	elseif {$curtype == "if"}\
	{
		p_changeif $curtag $localx $localy $globalx $globaly
		return
	}\
	elseif {$curtype == "and" || $curtype == "or"}\
	{
		p_changeandor $curtag $localx $localy $globalx $globaly
		return
	}
	set prevtag [p_gettag $curtag.first-1c]
	set CURPOS $prevtag.last-1c
	set tx [.lf.tx get $curtag.first $curtag.last]
	regsub -all "\n" $tx "" tx
	set txlist [split "$tx"  " "]
	set fct [lindex $txlist 0]
	set arg1 [lindex $txlist 1]
	set arg [lrange $txlist 1 end]
	set niv [p_getniv "$tx"]
	set tab_str [replicate "\t" $niv]
	if {$arg == "" || $fct == "" || $arg1 == ""}\
	{
		return
	}
	set pos [.lf.tx index $curtag.first]
	switch -regexp [lindex $txlist 0]\
	{
		\t*SET_VAR \
		{
			p_ask asked "Variable name: " [join [lindex $txlist 1] " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lindex $txlist 1] " "]
			}
			set asked [p_removespace "$asked"]
			set vn $asked
			set arg [join [lrange $txlist 2 end] " "]
			p_ask asked "Value: " "$arg"
			tkwait variable asked
			set pos [.lf.tx index $curtag.first]
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lrange $txlist 2 end] " "]
			}
			set str "${tab_str}SET_VAR $vn $asked\n"
			set type glob
		}
		\t*UNSET \
		{
			p_ask asked "Variable name: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "${tab_str}UNSET $asked\n"
			set type glob
		}
		\t*LOCAL_LOCK \
		{
			p_ask asked "Lock file: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "${tab_str}LOCAL_LOCK $asked\n"
			set type glob
		}
		\t*MAILDIR \
		{
			p_ask asked "Mail directory: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "${tab_str}MAILDIR $asked\n"
			set type glob
		}
		\t*LOGFILE \
		{
			p_ask asked "Log file: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "${tab_str}LOGFILE $asked\n"
			set type glob
		}
		\t*LOG$ \
		{
			p_ask asked "Line to add: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "\t*LOG $asked\n"
			set type glob
		}
		\t*INCLUDE \
		{
			p_ask asked "Include file: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}INCLUDE $asked\n"
			set type glob
		}
		\t*CUST_DECL \
		{
			p_ask asked "Custom declaration: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}CUST_DECL $asked\n"
			set type glob
		}
		\t*COMMENT \
		{
			p_ask asked "Comment: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}COMMENT $asked\n"
			set type glob
		}
		HEADER \
		{
			p_ask asked "Header contains: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "HEADER $asked"
			set type cond
		}
		BODY \
		{
			p_ask asked "Body contains: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "BODY $asked"
			set type cond
		}
		SUBJECT \
		{
			p_ask asked "Subject contains: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "SUBJECT $asked"
			set type cond
		}
		TO \
		{
			p_ask asked "To contains: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "TO $asked"
			set type cond
		}
		FROM \
		{
			p_ask asked "From contains: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "FROM $asked"
			set type cond
		}
		X_Loop \
		{
			p_ask asked "Your email address: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "X_Loop $asked"
			set type cond
		}
		< \
		{
			p_ask asked "Length < " [join $arg " "] "bytes"
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "< $asked"
			set type cond
		}
		> \
		{
			p_ask asked "Length > " [join $arg " "] "bytes"
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "> $asked"
			set type cond
		}
		EMPTY \
		{
			p_ask asked "Variable name: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set asked [p_removespace "$asked"]
			set str "EMPTY $asked"
			set type cond
		}
		VAR_MATCH \
		{
			p_ask asked "Variable name: " [join [lindex $txlist 1] " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lindex $txlist 1] " "]
			}
			set asked [p_removespace "$asked"]
			set v $asked
			p_ask asked "Match: " [join [lindex $txlist 2] " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lindex $txlist 2] " "]
			}
			set asked [p_removespace "$asked"]
			set str "VAR_MATCH $v $asked"
			set type cond
		}
		EXIT_CODE \
		{
			set tx [join [lrange $txlist 2 [expr [llength $txlist]-2]] " "]
			regsub -all {\\\(} $tx {(} tx
			regsub -all {\\\)} $tx {)} tx
			p_ask asked "Program: " "$tx"
			tkwait variable asked
			regsub -all {\(} $asked {\(} asked
			regsub -all {\)} $asked {\)} asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lrange $txlist 2 [expr [llength $txlist]-2]] " "]
			}
			set str "EXIT_CODE ( $asked )"
			set type cond
		}
		CUST_COND \
		{
			set tx [join [lrange $txlist 2 [expr [llength $txlist]-2]] " "]
			regsub -all {\\\(} $tx {(} tx
			regsub -all {\\\)} $tx {)} tx
			p_ask asked "Custom condition: " "$tx"
			tkwait variable asked
			regsub -all {\(} $asked {\(} asked
			regsub -all {\)} $asked {\)} asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lrange $txlist 2 [expr [llength $txlist]-2]] " "]
			}
			set str "CUST_COND ( $asked )"
			set type cond
		}
		\t+MAIL$ \
		{
			p_ask asked "Mail to: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			regsub -all { } $asked {,} asked
			set str "${tab_str}MAIL $asked\n"
			set type act
		}
		\t+MAILBOX \
		{
			p_ask asked "Send to mailbox: " [join $arg " "]
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}MAILBOX $asked\n"
			set type act
		}
		\t+h_REMOVE \
		{
			p_ask asked "Field to remove: " [join $arg " "]
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			if {[cindex $asked end] != ":"}\
			{
				append asked ":"
			}
			set str "${tab_str}h_REMOVE $asked\n"
			set type act
		}
		\t+h_SET \
		{
			p_ask asked "Field name: " [join [lindex $txlist 1] " "]
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lindex $txlist 1] " "]
			}
			if {[cindex $asked end] != ":"}\
			{
				append asked ":"
			}
			set f $asked
			p_ask asked "Value: " [join [lrange $txlist 2 end] " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lrange $txlist 2 end] " "]
			}
			set str "${tab_str}h_SET $f $asked\n"
			set type act
		}
		\t+h_ADD \
		{
			p_ask asked "Field name: " [join [lindex $txlist 1] " "]
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lindex $txlist 1] " "]
			}
			if {[cindex $asked end] != ":"}\
			{
				append asked ":"
			}
			set f $asked
			p_ask asked "Value: " [join [lrange $txlist 2 end] " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join [lrange $txlist 2 end] " "]
			}
			set str "${tab_str}h_ADD $f $asked\n"
			set type act
		}
		\t+h_PROGRAM \
		{
			p_ask asked "Send header to program: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}h_PROGRAM $asked\n"
			set type act
		}
		\t+b_PROGRAM \
		{
			p_ask asked "Send body to program: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}b_PROGRAM $asked\n"
			set type act
		}
		\t+hb_PROGRAM \
		{
			p_ask asked "Send header and body to program: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}hb_PROGRAM $asked\n"
			set type act
		}
		\t+h_FILTER \
		{
			p_ask asked "Filter program: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}h_FILTER $asked\n"
			set type act
		}
		\t+b_FILTER \
		{
			p_ask asked "Filter program: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}b_FILTER $asked\n"
			set type act
		}
		\t+hb_FILTER \
		{
			p_ask asked "Filter program: " [join $arg " "]
			tkwait variable asked
			if {$asked == "NOT_SET" || $asked == "CANCEL"}\
			{
				set asked [join $arg " "]
			}
			set str "${tab_str}hb_FILTER $asked\n"
			set type act
		}
	}
	.lf.tx configure -state normal
	.lf.tx delete $curtag.first $curtag.last
	p_addafter $type "$str"
	.lf.tx configure -state disabled
	p_tagremove redsel
}

proc p_changeif {curtag localx localy globalx globaly}\
{
	catch { destroy .if }
	catch { destroy .andor }
	set prevtag [p_gettag $curtag.first-1c]
	set tx [.lf.tx get $curtag.first $curtag.last]
	set niv [p_getniv "$tx"]
	set tab_str [replicate "\t" $niv]
	menu .if -tearoff 0
		.if add command -label "IF" \
			-command "
				.lf.tx configure -state normal
				.lf.tx delete $curtag.first $curtag.last
				.lf.tx insert $prevtag.last \"${tab_str}IF\n$tab_str\" \"$curtag if all\"
				p_tagremove redsel
				.lf.tx configure -state disabled
			"
		.if add command -label "IF_CONTINUE" \
			-command "
				.lf.tx configure -state normal
				.lf.tx delete $curtag.first $curtag.last
				.lf.tx insert $prevtag.last \"${tab_str}IF_CONTINUE\n$tab_str\" \"$curtag if all\"
				p_tagremove redsel
				.lf.tx configure -state disabled
			"
		.if add command -label "FILTER" \
			-command "
				.lf.tx configure -state normal
				.lf.tx delete $curtag.first $curtag.last
				.lf.tx insert $prevtag.last \"${tab_str}FILTER\n$tab_str\" \"$curtag if all\"
				p_tagremove redsel
				.lf.tx configure -state disabled
			"
		.if add command -label "ELSEIF_NOEXEC" \
			-command "
				.lf.tx configure -state normal
				.lf.tx delete $curtag.first $curtag.last
				.lf.tx insert $prevtag.last \"${tab_str}ELSEIF_NOEXEC\n$tab_str\" \"$curtag if all\"
				p_tagremove redsel
				.lf.tx configure -state disabled
			"
		.if add command -label "ELSEIF_ERROR" \
			-command "
				.lf.tx configure -state normal
				.lf.tx delete $curtag.first $curtag.last
				.lf.tx insert $prevtag.last \"${tab_str}ELSEIF_ERROR\n$tab_str\" \"$curtag if all\"
				p_tagremove redsel
				.lf.tx configure -state disabled
			"
	bind .if <Motion> {
		.mb.f.lb configure -text $IF([.if index active])
	}
	bind .if <Any-Leave> {
		.mb.f.lb configure -text ""
	}
	.if post $localx $localy
}

proc p_changeandor {curtag localx localy globalx globaly}\
{
	catch {destroy .andor}
	set prevtag [p_gettag $curtag.first-1c]
	set tx [.lf.tx get $curtag.first $curtag.last]
	set niv [p_getniv "$tx"]
	set tab_str [replicate "\t" $niv]
	menu .andor -tearoff 0
		.andor add command -label "AND" \
			-command "
				.lf.tx configure -state normal
				.lf.tx delete $curtag.first $curtag.last
				.lf.tx insert $prevtag.last \"\n${tab_str}AND \" \"$curtag and all\"
				p_tagremove redsel
				.lf.tx configure -state disabled
			"
		.andor add command -label "OR" \
			-command "
				.lf.tx configure -state normal
				.lf.tx delete $curtag.first $curtag.last
				.lf.tx insert $prevtag.last \"\n${tab_str}OR \" \"$curtag or all\"
				p_tagremove redsel
				.lf.tx configure -state disabled
			"
	.andor post $localx $localy
}

proc p_group {localx localy globalx globaly}\
{
	global STEP
	global ID
	.right unpost
	.right delete 0 end
	set curtype [p_gettype @$localx,$localy]
	if {$curtype == ""}\
	{
		return
	}
	set curtag [p_gettag @$localx,$localy]
	if {$curtag == "start"}\
	{
		return
	}
	lappend listtag $curtag
	set nexttype [p_gettype $curtag.last+1c]
	set nexttag [p_gettag $curtag.last+1c]
	set prevtype [p_gettype $curtag.first-1c]
	set prevtag [p_gettag $curtag.first-1c]
	set tx [.lf.tx get $curtag.first $curtag.last]
	set curniv [p_getniv "$tx"]
	if {$nexttag != ""}\
	{
		set tx [.lf.tx get $nexttag.first $nexttag.last]
		set nextniv [p_getniv "$tx"]
	}
	if {$prevtag != "id0"}\
	{
		set tx [.lf.tx get $prevtag.first $prevtag.last]
		set prevniv [p_getniv "$tx"]
	}
	if {$curtype == "if"}\
	{
		while {$nexttype != ""}\
		{
			lappend listtag $nexttag
			if {$nexttype == "eblock" && $nextniv == $curniv}\
			{
				break
			}
			set nexttype [p_gettype $nexttag.last+1c]
			set nexttag [p_gettag $nexttag.last+1c]
			catch {
				set tx [.lf.tx get $nexttag.first $nexttag.last]
				set nextniv [p_getniv "$tx"]
			}
		}
	}\
	elseif {$curtype == "cond"}\
	{
		if {$prevtype == "and" || $prevtype == "or"}\
		{
			lappend listtag $prevtag
		}\
		elseif {$nexttype == "and" || $nexttype == "or"}\
		{
			lappend listtag $nexttag
			if {$prevtype == "not"}\
			{
				lappend listtag $prevtag
			}
		}\
	 	elseif {$prevtype == "not"}\
		{
			lappend listtag $prevtag
			if {[p_gettype $prevtag.first-1c] == "and" || [p_gettype $prevtag.first-1c] == "or"}\
			{
				lappend listtag [p_gettag $prevtag.first-1c]
			}
		}
	}\
	elseif {$curtype == "and"}\
	{
		if {$nexttype == "cond"}\
		{
			lappend listtag $nexttag
		}\
		elseif {$nexttype == "not"}\
		{
			lappend listtag $nexttag
			if {[p_gettype $nexttag.last+1c] == "cond"}\
			{
				lappend listtag [p_gettag $nexttag.last+1c]
			}
		}
	}\
	elseif {$curtype == "or"}\
	{
		if {$nexttype == "cond"}\
		{
			lappend listtag $nexttag
		}\
		elseif {$nexttype == "not"}\
		{
			lappend listtag $nexttag
			if {[p_gettype $nexttag.last+1c] == "cond"}\
			{
				lappend listtag [p_gettag $nexttag.last+1c]
			}
		}
	}\
	elseif {$curtype == "sblock"}\
	{
		while {$nexttype != ""}\
		{
			lappend listtag $nexttag
			if {$nexttype == "eblock" && $nextniv == $curniv}\
			{
				break
			}
			set nexttype [p_gettype $nexttag.last+1c]
			set nexttag [p_gettag $nexttag.last+1c]
			catch {
				set tx [.lf.tx get $nexttag.first $nexttag.last]
				set nextniv [p_getniv "$tx"]
			}
		}
		lappend listtag $prevtag
		while {$prevtype != "if"}\
		{
			set prevtype [p_gettype $prevtag.first-1c]
			set prevtag [p_gettag $prevtag.first-1c]
			lappend listtag $prevtag
		}
	}\
	elseif {$curtype == "eblock"}\
	{
		while {$prevtype != "start"}\
		{
			lappend listtag $prevtag
			if {$prevtype == "if" && $prevniv == $curniv}\
			{
				break
			}
			set prevtype [p_gettype $prevtag.first-1c]
			set prevtag [p_gettag $prevtag.first-1c]
			catch {
				set tx [.lf.tx get $prevtag.first $prevtag.last]
				set prevniv [p_getniv "$tx"]
			}
		}
	}
	.lf.tx configure -state normal
	p_tagremove redsel
	foreach tag $listtag \
	{
		if {$tag != "id0"}\
		{
			.lf.tx tag add redsel $tag.first $tag.last
		}
	}
	.lf.tx configure -state disabled
}

proc p_tagremove {tag}\
{
	global ID
	.lf.tx configure -state normal
	loop i 1 [expr $ID+1] \
	{
		catch {.lf.tx tag remove redsel id$i.first id$i.last}
	}
	.lf.tx configure -state disabled
}

proc p_ask {var {befstr ""} {value ""} {aftstr ""}}\
{
	upvar #0 $var asked
	update
	if {[winfo exists .ask]}\
	{
		destroy .ask
	}
	toplevel .ask
	wm title .ask "Enter a value"
	wm geometry .ask +50+50
	wm resizable .ask 0 0
	frame .ask.t
	pack .ask.t -side top
	label .ask.t.bef -text $befstr
	pack .ask.t.bef -side left
	text .ask.t.e -width 30 -wrap word -height 2
	.ask.t.e insert 1.0 $value
	bind .ask.t.e <Return> {break}
	bind .ask.t.e <Delete> "[bind Text <Delete>]; break"
	bind .ask.t.e <BackSpace> "[bind Text <BackSpace>]; break"
	bindtags .ask.t.e {.ask.t.e Text all .}
	pack .ask.t.e -side left	
	label .ask.t.aft -text $aftstr
	pack .ask.t.aft -side left
	frame .ask.b
	pack .ask.b -side bottom
	button .ask.b.ok -width 7 -text "OK" \
		-command {
			set asked [.ask.t.e get 1.0 end]
			regsub -all "\n" $asked "" asked
			if {[ctype space $asked] || $asked == ""}\
			{
				set asked "NOT_SET"
			}
			grab release .ask
			destroy .ask
		}
	pack .ask.b.ok -side left
	button .ask.b.cancel -width 7 -text "Cancel" \
		-command {
			set asked "CANCEL"
			grab release .ask
			destroy .ask
		}
	pack .ask.b.cancel -side left
	focus .ask.t.e
	grab set .ask
}

proc p_postavail {localx localy globalx globaly}\
{
	global STEP CURPOS asked niv tab_str OPER
	.right unpost
	.right delete 0 end
	set curtype [p_gettype @$localx,$localy]
	if {$curtype == ""}\
	{
		set aa [.lf.tx bbox all.last-1c]
		set CURPOS @[lindex $aa 0],[lindex $aa 1]
		set curtype [p_gettype $CURPOS]
	}
	set curtag [p_gettag @$localx,$localy]
	if {$curtag == ""}\
	{
		set curtag [p_gettag $CURPOS]
	}
	set nexttype [p_gettype $curtag.last+1c]
	if {$nexttype != ""}\
	{
		set prevlist [keylget STEP $nexttype.prev]
	}\
	else\
	{
		set prevlist [keylget STEP $curtype.next]
	} 
	set tx [.lf.tx get $curtag.first $curtag.last]
	set niv [p_getniv "$tx"]
	if {$curtype == "sblock"}\
	{
		incr niv
	}
	if {$curtype == "cond"}\
	{
		set prevtype [p_gettype $curtag.first-1c]
		set prevtag [p_gettag $curtag.first-1c]
		while {$prevtype != "if"}\
		{
			set prevtype [p_gettype $prevtag.first-1c]
			set prevtag [p_gettag $prevtag.first-1c]
		}
		set tx [.lf.tx get $prevtag.first $prevtag.last]
		set niv [p_getniv "$tx"]
	}
	set tab_str [replicate "\t" $niv]
	foreach b [intersect [keylget STEP $curtype.next] $prevlist]\
	{
		switch -exact $b \
		{
			glob	{
				if {[lsearch $prevlist "glob"] != -1}\
				{
				.right add cascade -label "Variables" -menu .right.globvar
				.right add cascade -label "Log management" -menu .right.globlog
				.right add separator
				.right add command -label "Local lockfile" \
					-command {
						p_ask asked "Lock file: "
						tkwait variable asked
						set asked [p_removespace "$asked"]
						if {$asked != "CANCEL"}\
						{
							p_addafter "glob" "${tab_str}LOCAL_LOCK $asked\n"
						}
					}
				.right add command -label "Use default lockfile" \
					-command {p_addafter "glob" "${tab_str}DEF_LOCK\n"}
				.right add separator
				.right add command -label "Include rcfile" \
					-command {
						p_ask asked "Include rcfile: "
						tkwait variable asked
						if {$asked != "CANCEL"}\
						{
							p_addafter "glob" "${tab_str}INCLUDE $asked\n"
						}
					}
				.right add separator
				.right add command -label "Custom declaration" \
					-command {
						p_ask asked "Custom declaration: "
						tkwait variable asked
						if {$asked != "CANCEL"}\
						{
							p_addafter "glob" "${tab_str}CUST_DECL $asked\n"
						}
					}
				.right add command -label "Comment" \
					-command {
						p_ask asked "Comment: "
						tkwait variable asked
						if {$asked != "CANCEL"}\
						{
							p_addafter "glob" "${tab_str}COMMENT $asked\n"
						}
					}
				.right add separator
				}
			}
			if	{
				if {[lsearch $prevlist "if"] != -1}\
				{
				.right add cascade -label "IF commands" -menu .right.if
				.right add separator
				}
			}
			not	{
				if {[lsearch $prevlist "not"] != -1}\
				{
				.right add command -label "NOT" \
					-command {p_addafter "not" "NOT "}
				.right add separator
				}
				}
			#cond	{
			#	if {[lsearch $prevlist "cond"] != -1}\
			#	{
			#	.right add cascade -label "Conditions" -menu .right.cond
			#	.right add separator
			#	}
			#}
			and	{
				if {[lsearch $prevlist "and"] != -1}\
				{
				.right add cascade -label "AND conditions" -menu .right.andcond 
				.right add separator
				}
			}
			or	{
				if {[lsearch $prevlist "or"] != -1}\
				{
				.right add cascade -label "OR conditions" -menu .right.orcond 
			
				.right add separator
				}
			}
			act	{
				if {[lsearch $prevlist "act"] != -1 && $niv > 0}\
				{
				.right add cascade -label "Actions" -menu .right.act
				.right add separator
				}
			}
		}
	}
	.right delete end
	.right post $globalx $globaly
}

proc p_gettag {pos}\
{
	set tag [lindex [.lf.tx tag names $pos] 0]
	if {$tag == ""}\
	{
		return ""
	}
	set i 1
	while {! [ctype digit [crange $tag 2 end]]}\
	{
		set tag [lindex [.lf.tx tag names $pos] $i]
		incr i
	}
	return $tag
}

proc p_gettype {pos}\
{
	set tag [lindex [.lf.tx tag names $pos] 0]
	if {$tag == ""}\
	{
		return ""
	}
	set i 1
	while {[ctype digit [crange $tag 2 end]] || $tag == "all" || $tag == "redsel" || $tag == "keyword" || $tag == "sel"}\
	{
		set tag [lindex [.lf.tx tag names $pos] $i]
		incr i
	}
	return $tag
}

proc p_addafter {type str}\
{
	global STEP CURPOS
	set newid [p_getnextid]
	.lf.tx configure -state normal
	set curtag [p_gettag $CURPOS]
	set curtype [p_gettype $CURPOS]
	set nexttype [p_gettype $curtag.last+1c]
	if {$nexttype != ""}\
	{
		set prev [lsearch -exact [keylget STEP $nexttype.prev] $type]
	}\
	else\
	{
		set prev 0
	}
	set curtag [p_gettag $CURPOS]
	if {[lsearch -exact [keylget STEP $curtype.next] $type] != -1 && \
		$prev != -1}\
	{ 
		set l [split $str " "]
		if {$type == "and" || $type == "or"}\
		{
			set keyword ""
			set args "$str"
		}\
		elseif {[cindex [lindex $l 0] end] == "\n"}\
		{
			set keyword "[lindex $l 0]"
			set args ""
		}\
		else\
		{
			set keyword "[lindex $l 0] "
			set args [join [lrange $l 1 end] " "]
		}
		.lf.tx insert $curtag.last "$keyword" "id$newid $type all keyword" "$args" "id$newid $type all"
	}\
	else\
	{
		myError "An unexpexted error has occured. Please retry or report the bug."
	}
	set CURPOS id$newid.last-1c
	.lf.tx see id$newid.first
	.lf.tx configure -state disabled
}

proc p_getnextid {}\
{
	global ID
	incr ID
	return $ID
}

