%option noyywrap
%{
#include "reciproc2procmail.tab.h"
%}

%x cust_cond
%x condition
%x cond_arg

/* ------------------- Rules space -------------------- */
%%

^[\t]*IF$		{BEGIN(condition); return IF;}
^[\t]*IF_CONTINUE$	{BEGIN(condition); return IF_CONTINUE;}
^[\t]*FILTER$		{BEGIN(condition); return FILTER;}
^[\t]*ELSEIF_NOEXEC$	{BEGIN(condition); return ELSEIF_NOEXEC;}
^[\t]*ELSEIF_ERROR$	{BEGIN(condition); return ELSEIF_ERROR;}

<condition>TRUE		return TRUE;
<condition>FALSE	return FALSE;
<condition>HEADER	{BEGIN(cond_arg); return HEADER;}
<condition>BODY		{BEGIN(cond_arg); return BODY;}
<condition>SUBJECT	{BEGIN(cond_arg); return SUBJECT;}
<condition>TO		{BEGIN(cond_arg); return TO;}
<condition>FROM		{BEGIN(cond_arg); return FROM;}
<condition>X_Loop	{BEGIN(cond_arg); return X_Loop;}
<condition>\<		{BEGIN(cond_arg); return INF;}
<condition>\>		{BEGIN(cond_arg); return SUP;}
<condition>EMPTY	{BEGIN(cond_arg); return EMPTY;}
<condition>VAR_MATCH	{BEGIN(cond_arg); return VAR_MATCH;}

<condition>FROM_MAILER	return FROM_MAILER;
<condition>FROM_DAEMON	return FROM_DAEMON;

<condition>CUST_COND	{ BEGIN(cust_cond); return CUST_COND; }
<cust_cond>\(	{}
<cust_cond>\)	BEGIN(condition);
<cust_cond>([^\ \	\(\)\n]|\\\ |\\\	|\\\(|\\\)|\\\\)+	{
		yylval=(char *)malloc(yyleng);
		strcpy(yylval,yytext);
		return WORD;
	}

<condition>EXIT_CODE	{ BEGIN(cust_cond); return EXIT_CODE; }

<condition>NOT		return NOT;
<condition>AND		return AND;
<condition>OR		return OR;

^[\t]*MAIL		return MAIL;
^[\t]*MAILBOX		return MAILBOX;
^[\t]*h_PROGRAM		return h_PROGRAM;
^[\t]*b_PROGRAM		return b_PROGRAM;
^[\t]*hb_PROGRAM	return hb_PROGRAM;
^[\t]*h_REMOVE		return h_REMOVE;
^[\t]*h_SET		return h_SET;
^[\t]*h_ADD		return h_ADD;
^[\t]*h_FILTER		return h_FILTER;
^[\t]*b_FILTER		return b_FILTER;
^[\t]*hb_FILTER		return hb_FILTER;
^[\t]*DELETE		return DELETE;

^[\t]*SET_VAR		return SET_VAR;
^[\t]*UNSET		return UNSET;
^[\t]*LOCAL_LOCK	return LOCAL_LOCK;
^[\t]*DEF_LOCK		return DEF_LOCK;
^[\t]*MAILDIR		return MAILDIR;

^[\t]*LOGFILE		return LOGFILE;
^[\t]*LOG		return LOG;
^[\t]*LOGABSTRACT	return LOGABSTRACT;
^[\t]*NO_LOGABSTRACT	return NO_LOGABSTRACT;
^[\t]*VERBOSE		return VERBOSE;
^[\t]*NO_VERBOSE	return NO_VERBOSE;

^[\t]*INCLUDE		return INCLUDE;

^[\t]*CUST_DECL		return CUST_DECL;
^[\t]*COMMENT		return COMMENT;

<cond_arg>([^\ \	\n]|\\\ |\\\	)+	{
			BEGIN(condition);
			yylval=(char *)malloc(yyleng);
			strcpy(yylval,yytext);
			return WORD;
		}


<condition,INITIAL>([^\ \	\n]|\\\ |\\\	)+	{
			yylval=(char *)malloc(yyleng);
			strcpy(yylval,yytext);
			return WORD;
		}

<condition>^[\t]*\{$		{BEGIN(0); return SBLOCK;}
^[\t]*\}$		return EBLOCK;

<condition,INITIAL>.|\n		{}

%%



