%{
#define YYSTYPE char*
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "reciproc2procmail.yy.c"
	int andflag = 1;
	int i, n = 0;
	int cond = 0;
	int egrep_body = 0;
	int evalvar = 0;
	int niv = 0;
	char buf1[1000], buf2[1000], temp[1000], remescstr[100];
	char str[200], lock[100], flags[10], tab_str[20];
	int if_continue[20], filter[20];
	int ind_continue = 0, ind_filter =  0;
char *c_var(char *str);
char *fc_esc(char *str);
char *rem_esc(char *str);

%}


/* BISON Declarations */
%token IF IF_CONTINUE FILTER ELSEIF_NOEXEC ELSEIF_ERROR
%token TRUE FALSE HEADER BODY SUBJECT TO FROM X_Loop INF SUP EMPTY VAR_MATCH FROM_MAILER FROM_DAEMON CUST_COND EXIT_CODE
%token WORD MAILBOX MAIL h_REMOVE h_SET h_ADD h_PROGRAM b_PROGRAM hb_PROGRAM h_FILTER b_FILTER hb_FILTER DELETE
%token SET_VAR UNSET LOCAL_LOCK DEF_LOCK MAILDIR LOGFILE LOG LOGABSTRACT NO_LOGABSTRACT VERBOSE NO_VERBOSE INCLUDE CUST_DECL COMMENT
%token SBLOCK EBLOCK
%left OR
%left AND
%left NOT
/* Grammar follows */
%%


input:    /* empty string */
        | input recipe
	| error  	{ exit(1);		}
;

recipe:	ifexpr { printf("%smatch%d = 0", tab_str, cond); } conds { 
			if(n)
			{
				printf("\n%s:0 %s\n", tab_str, flags);
				printf("%s* match%d ?? ^^1^^\n", tab_str, cond);
				n = 0;
			}
		} SBLOCK {
			printf("%s{\n", tab_str);
			niv++;
			strcpy(tab_str, "");
			for(i = 0; i < niv; i++)
				strcat(tab_str, "\t");
			filter[++ind_filter] = 1;
		} acts EBLOCK {
			if (! if_continue[--ind_continue] && ! filter[ind_filter--])
			{
				printf("\n%s:0\n%s/dev/null\n", tab_str, tab_str);
			}
			niv--;
			strcpy(tab_str, "");
			for(i = 0; i < niv; i++)
				strcat(tab_str, "\t");
			printf("%s}\n\n", tab_str);
		}
	| decls

ifexpr:	IF		{ if_continue[ind_continue++] = 0; strcpy(flags, ""); cond++; }
	| IF_CONTINUE	{ if_continue[ind_continue++] = 0; strcpy(flags, "c"); cond++; }
	| FILTER	{ if_continue[ind_continue++] = 1; strcpy(flags, ""); cond++; }
	| ELSEIF_NOEXEC	{ if_continue[ind_continue++] = 0; strcpy(flags, "E"); cond++; }
	| ELSEIF_ERROR	{ if_continue[ind_continue++] = 0; strcpy(flags, "e"); cond++; }



conds:	/* empty */	{ printf("\n%s:0 %s\n", tab_str, flags); }
	| andexpr	{ 
			if (egrep_body)
			{
				printf("\n%s:0 BH %s\n%s", tab_str, flags, buf2);
			}
			else
			{
				printf("\n%s:0 %s\n%s", tab_str, flags, buf2);
			}
			strcpy(buf2, ""); 
		}
	| orexpr	{	}	
;

andexpr: cond		{	}
	| andexpr AND cond	{	}
;

orexpr:	andexpr	{	
			if (egrep_body)
			{
				if(n >= 1)
				{
					printf("\n%s:0 BH E\n%s", tab_str, buf2);	
				}
				else
				{
					printf("\n%s:0 BH\n%s", tab_str, buf2);	
				}
			}
			else
			{
				if(n >= 1)
				{
					printf("\n%s:0 E\n%s", tab_str, buf2);	
				}
				else
				{
					printf("\n%s:0\n%s", tab_str, buf2);	
				}
			}
			n++;
			printf("%s{ match%d = 1 }\n", tab_str, cond);
			strcpy(buf2, ""); 
			egrep_body = 0;
		}
	| orexpr OR orexpr {	} 
;

cond: 	NOT		{
			sprintf(str, "%s* !\n", tab_str);
			strcat(buf2, str);
		}
	| TRUE	{
			sprintf(str, "%s* \n", tab_str);
			strcat(buf2, str);
		}
	| NOT TRUE {
			sprintf(str, "%s* !\n", tab_str);
			strcat(buf2, str);
		}
	| FALSE	{
			sprintf(str, "%s* !\n", tab_str);
			strcat(buf2, str);
		}
	| NOT FALSE {
			sprintf(str, "%s* \n", tab_str);
			strcat(buf2, str);
		}
	| HEADER WORD	{
			sprintf(str, "%s* %s%s%s\n", tab_str, c_var($2), fc_esc($2), $2);
			strcat(buf2, str);
		}
	| NOT HEADER WORD	{
			sprintf(str, "%s* %s! %s%s\n", tab_str, c_var($3), fc_esc($3), $3);
			strcat(buf2, str);
		}
	| BODY WORD	{
			sprintf(str, "%s* %s%s%s\n", tab_str, c_var($2), fc_esc($2), $2);
			strcat(buf2, str);
			egrep_body = 1;
		}
	| NOT BODY WORD	{
			sprintf(str, "%s* %s! %s%s\n", tab_str, c_var($3), fc_esc($3), $3);
			strcat(buf2, str);
			egrep_body = 1;
		}
	| SUBJECT WORD	{
			sprintf(str, "%s* %s^Subject:.*%s\n", tab_str, c_var($2), $2);
			strcat(buf2, str);
		}
	| NOT SUBJECT WORD	{
			sprintf(str, "%s* %s! ^Subject:.*%s\n", tab_str, c_var($3), $3);
			strcat(buf2, str);
		}
	| TO WORD	{
			sprintf(str, "%s* %s^TO_.*%s\n", tab_str, c_var($2), $2);
			strcat(buf2, str);
		}
	| NOT TO WORD	{
			sprintf(str, "%s* %s! ^TO_.*%s\n", tab_str, c_var($3), $3);
			strcat(buf2, str);
		}
	| FROM WORD	{
			sprintf(str, "%s* %s^From:.*%s\n", tab_str, c_var($2), $2);
			strcat(buf2, str);
		}
	| NOT FROM WORD	{
			sprintf(str, "%s* %s! ^From:.*%s\n", tab_str, c_var($3), $3);
			strcat(buf2, str);
		}
	| X_Loop WORD	{
			sprintf(str, "%s* %s^X-Loop: %s\n", tab_str, c_var($2), $2);
			strcat(buf2, str);
		}
	| NOT X_Loop WORD	{
			sprintf(str, "%s* %s! ^X-Loop: %s\n", tab_str, c_var($3), $3);
			strcat(buf2, str);
		}
	| FROM_MAILER	{
			sprintf(str, "%s* ^FROM_MAILER\n", tab_str);
			strcat(buf2, str);
		}
	| NOT FROM_MAILER	{
			sprintf(str, "%s* ! ^FROM_MAILER\n", tab_str);
			strcat(buf2, str);
		}
	| FROM_DAEMON	{
			sprintf(str, "%s* ^FROM_DAEMON\n", tab_str);
			strcat(buf2, str);
		}
	| NOT FROM_DAEMON	{
			sprintf(str, "%s* ! ^FROM_DAEMON\n", tab_str);
			strcat(buf2, str);
		}
	| INF WORD	{
			sprintf(str, "%s* %s< %s\n", tab_str, c_var($2), $2);
			strcat(buf2, str);
		}
	| NOT INF WORD	{
			sprintf(str, "%s* %s! < %s\n", tab_str, c_var($3), $3);
			strcat(buf2, str);
		}
	| SUP WORD	{
			sprintf(str, "%s* %s> %s\n", tab_str, c_var($2), $2);
			strcat(buf2, str);
		}
	| NOT SUP WORD	{
			sprintf(str, "%s* %s! > %s\n", tab_str, c_var($3), $3);
			strcat(buf2, str);
		}
	| EMPTY WORD	{
			sprintf(str, "%s* %s%s ?? ^^^^\n", tab_str, c_var($2), $2);
			strcat(buf2, str);
		}
	| NOT EMPTY WORD	{
			sprintf(str, "%s* %s! %s ?? ^^^^\n", tab_str, c_var($3), $3);
			strcat(buf2, str);
		}
	| VAR_MATCH WORD WORD	{
			sprintf(str, "%s* %s%s ?? %s\n", tab_str, c_var($3), $2, $3);
			strcat(buf2, str);
		}
	| NOT VAR_MATCH WORD WORD	{
			sprintf(str, "%s* %s! %s ?? %s\n", tab_str, c_var($4), $3, $4);
			strcat(buf2, str);
		}
	| CUST_COND { 
			strcat(buf2, tab_str);
			strcat(buf2, "*");
			strcpy(str, ""); 
		} wordlist {
			strcat(buf2, str);
			strcat(buf2, "\n");
			egrep_body = 1;
		}
	| NOT CUST_COND { 
			strcat(buf2, tab_str);
			strcat(buf2, "* !");
			strcpy(str, "");
		} wordlist {
			strcat(buf2, str);
			strcat(buf2, "\n");
			egrep_body = 1;
		}
	| EXIT_CODE { 
			strcat(buf2, tab_str);
			strcat(buf2, "* ");
			strcpy(str, ""); 
			evalvar = 0;
		} wordlist {
			if(evalvar)
			{
				strcat(buf2, "$ ?");
			}
			else
			{
				strcat(buf2, "?");
			}
			strcat(buf2, str);
			strcat(buf2, "\n");
			egrep_body = 1;
		}
	| NOT EXIT_CODE { 
			strcat(buf2, tab_str);
			strcat(buf2, "* ! ");
			strcpy(str, "");
			evalvar = 0;
		} wordlist {
			if(evalvar)
			{
				strcat(buf2, "$ ? ");
			}
			else
			{
				strcat(buf2, "? ");
			}
			strcat(buf2, str);
			strcat(buf2, "\n");
			egrep_body = 1;
		}
;


acts:	/* empty  */
	| act			{	}
	| actlist 		{	}

actlist: 	act		{	}
		| actlist act 	{	}


act:	MAILBOX WORD { filter[ind_filter] = 0; printf("\n%s:0 c:%s\n%s%s\n", tab_str, lock, tab_str, $2); 	}
	| MAIL { filter[ind_filter] = 0; printf("\n%s:0 c%s\n%s!", tab_str, lock, tab_str);	} endline { printf("\n"); }
	| h_REMOVE WORD { printf("\n%s:0 fwh\n%s| formail -I%s\n", tab_str, tab_str, $2);	}
	| h_SET WORD { printf("\n%s:0 fwh\n%s| formail -i\"%s", tab_str, tab_str, $2); } endline { printf("\"\n"); }
	| h_ADD WORD { printf("\n%s:0 fwh\n%s| formail -A\"%s", tab_str, tab_str, $2); } endline { printf("\"\n"); }
	| h_PROGRAM { filter[ind_filter] = 0; printf("\n%s:0 hc:%s\n%s|", tab_str, lock, tab_str);	} endline { printf("\n"); }
	| b_PROGRAM { filter[ind_filter] = 0; printf("\n%s:0 bc:%s\n%s|", tab_str, lock, tab_str);	} endline { printf("\n"); }
	| hb_PROGRAM { filter[ind_filter] = 0; printf("\n%s:0 c:%s\n%s|", tab_str, lock, tab_str);	} endline { printf("\n"); }
	| h_FILTER { printf("\n%s:0 fwh:%s\n%s|", tab_str, lock, tab_str); } endline { printf("\n"); }
	| b_FILTER { printf("\n%s:0 fwb:%s\n%s|", tab_str, lock, tab_str); } endline { printf("\n"); }
	| hb_FILTER { printf("\n%s:0 fw:%s\n%s|", tab_str, lock, tab_str); } endline { printf("\n"); }
	| DELETE { printf("\n%s:0\n%s/dev/null\n", tab_str, tab_str); }
	| recipe
;

endline:	/* empty */
		| endline WORD { printf(" %s", $2);	}
;

wordlist:	/* empty */
		| wordlist WORD { 
				strcat(str, " ");
				strcat(str, rem_esc($2));
				if(strcmp(c_var($2), ""))
				{
					evalvar = 1;
				}
			}
;


decls:	DEF_LOCK		{ strcpy(lock, "");		}
	| LOCAL_LOCK WORD	{ strcpy(lock, $2);		}
	| MAILDIR WORD		{ printf("%sMAILDIR = \"%s\"\n", tab_str, $2);}
	| LOGFILE WORD		{ printf("%sLOGFILE = \"%s\"\n", tab_str, $2);}
	| LOG WORD		{ printf("%sLOG = \"%s", tab_str, $2);} endline { printf("\n\"\n"); }
	| LOGABSTRACT		{ printf("%sLOGABSTRACT = \"all\"\n", tab_str);	}
	| NO_LOGABSTRACT	{ printf("%sLOGABSTRACT = \"no\"\n", tab_str);	}
	| VERBOSE		{ printf("%sVERBOSE = \"yes\"\n", tab_str);	}
	| NO_VERBOSE		{ printf("%sVERBOSE = \"no\"\n", tab_str);	}
	| INCLUDE WORD		{ printf("%sINCLUDERC = \"%s", tab_str, $2); } endline { printf("\"\n"); }
	| CUST_DECL WORD { printf("%s%s", tab_str, $2); } endline { printf("\n"); }	
	| COMMENT 		{ printf("%s#", tab_str);		} endline { printf("\n"); }
	| SET_VAR WORD WORD	{ printf("%s%s = \"%s", tab_str, $2, $3);	} endline  { printf("\"\n"); }
	| UNSET WORD { printf("\n%s:0\n%s{ %s }\n", tab_str, tab_str, $2); }


%%

char * fc_esc(char *str)
{
	if(str[0] == '<' || str[0] == '>' || str[0] == '!')
		return("\\");
	else
		return("");
}

char * c_var(char *str)
{
	if(strstr(str, "${") != NULL)
	{
		return "$ ";
	}
	else
	{
		return "";
	}
}

char * rem_esc(char *str)
{
	int i, j;
	strcpy(remescstr, "");
	strcpy(remescstr, str);
	for(i = 0; i < strlen(remescstr)-1; i++)
	{
		if(remescstr[i] == '\\' && (remescstr[i+1] == '(' ||
			remescstr[i+1] == ')'))
		{
			for(j = i; j < strlen(remescstr); j++)
				remescstr[j] = remescstr[j+1];
			remescstr[j] = '\0';
		}
	}
	return(remescstr);
}
   
main ()
{
	yyparse ();
}
   

yyerror (s)  /* Called by yyparse on error */
	char *s;
{
	printf ("%s\n", s);
}

